/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2015-2019 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2015 Grigory Filatov <gfilatov@inbox.ru>
 * Copyright 2015 Dima  < ???? >
*/

#include "minigui.ch"
#include "excel.ch"
#include "metrocolor.ch"

#define PATH_STARTUP     GetStartUpFolder() + "\"
#define PATH_TEMP        GetTempFolder() + "\"
///////////////////////////////////////////////////////////////////////////////////
FUNCTION MyExcelOle( cAlias, nOrder, aField, cFileXls, lActivate, cTitle, lSave, aHatShapes )
   LOCAL hWnd, cMsg, cPole, nFSize1, aFColor, aFBColor, xValue, nDecPole, cVal, nJ
   LOCAL nI, nLine, aCapTbls, aDim, nSize, cFont2, nFSize2, nErrDos, lItogo := .F.
   LOCAL oExcel, oWorkBook, nCount, oSheet, oRange, nRowXls, nColXls, nVerExcel
   DEFAULT nOrder := 0
   DEFAULT aHatShapes := { WHITE, COLOR_PURPLE_METRO, 14 } //   

   CursorWait()
   WaitThreadCreate( '   EXCEL ...' )   //   -> WaitThread.prg

   //  Ole  HBWIN.lib
   IF ( oExcel := win_oleCreateObject( "Excel.Application" ) ) == NIL 
      WaitThreadClose()  //   
      CursorArrow()
      cMsg := ""
      IF Hb_LangSelect() == "ru.RU1251"
         cMsg += "MS Excel   !;;"
         cVal := "!"
      ELSE
         cMsg += "MS Excel is not available !;;Error"
         cVal := "Error!"
      ENDIF
      cMsg += " [ " + win_oleErrorText() + " ];;"
      MyStop( cMsg , cVal )
      RETURN Nil 
   ENDIF

   //_HMG_IsModalActive := .F.  //      

   //   
   aFColor := aHatShapes[1]
   aFBColor:= aHatShapes[2]
   nFSize1 := aHatShapes[3]

   // --------   ------------------
   // ------ 1  -    () ---------------
   // (*)      Excel
   //          0  255. 
   //     ,     ,
   //      TE000127106. 
   //      8,43 . 
   //     0,   .
   //        0  409. 
   //        (1    1/72   0,035 ).
   //      12,75  ( 1/6   0,4 ). 
   //     0,   .
   aCapTbls := {}
   FOR nI := 1 TO LEN( aField )
       AADD( aCapTbls , 0 )       //    
       cPole := aField[ nI , 2 ]  //   
       IF AT(";", cPole) == 0     //     
          aCapTbls[nI] := LEN(cPole)
       ELSE
          aDim := HB_ATokens(cPole,";",.F.,.F.)
          FOR nJ := 1 TO LEN(aDim) 
              aCapTbls[nI] := MAX(aCapTbls[nI],LEN(aDim[nJ]))
          NEXT
       ENDIF
   NEXT     
   // --------         ------
   SELECT( cAlias )
   FOR nI := 1 TO LEN( aField )
       cPole := aField[ nI , 1 ] //   DBF
       IF cPole == "ORDKEYNO()"
          nSize := LEN("0000") 
       ELSE
          nSize := FieldSize( FIELDNUM(cPole) ) 
       ENDIF
       aCapTbls[nI] := MAX( aCapTbls[nI], nSize )
   NEXT
   // --------   ------------------

   // -------  Excel ---------------
   oExcel := TOleAuto():NEW( "Excel.Application" )  // 
   nVerExcel := VAL( oExcel:Version )   //  Excel
   oWorkBook := oExcel:WorkBooks:Add()  //   Excel

   oExcel:ActiveWindow:DisplayZeros:=.F. //   0,00  

   oSheet := oExcel:ActiveSheet()
   // Set font for all cells
   cFont2 := "Arial" ;  nFSize2 := 14
   oSheet:Cells:Font:Name := cFont2
   oSheet:Cells:Font:Size := nFSize2
   
   // -------   ---------------
   // 1   -  
   // 2   -  
   // 3   -  
   // 4   -     
   nLine := 4
   nCount := LEN( aField )  //   

   // -------   ---------------
   oSheet:Cells( 1, 1 ):Value := cTitle
   oSheet:Cells( 1, 1 ):Font:Size := nFSize1
   //      1  nCount   
   oSheet:Range(oSheet:cells(1,1),oSheet:cells(1,nCount)):MergeCells:=.t. 
   oSheet:Cells( 1, 1 ):HorizontalAlignment := xlCenter 

   // --------   ------------------
   FOR nI := 1 TO LEN( aField )
       // ------ 1  -    () ---------------
       //   (*)
       //nSize := GetTxtWidth( Replicate("0",aCapTbls[nI]), nFSize2, cFont2 )
       oSheet:columns( nI ):ColumnWidth := aCapTbls[nI] + 7  //  7  

       cPole := aField[ nI , 2 ]   //   
       cPole := ATREPL( ";", cPole, CHR(10) )
       oSheet:Cells( nLine-1, nI ):Value := cPole //   
       oSheet:Cells( nLine-1, nI ):Borders():LineStyle := 1
       oSheet:Cells( nLine-1, nI ):HorizontalAlignment := xlCenter 
       oSheet:Cells( nLine-1, nI ):VerticalAlignment := xlCenter 
       oSheet:Cells( nLine-1, nI ):Font:Bold := .T. 
       //   
       oSheet:Cells( nLine-1, nI ):Interior:Color:= RGB(aFBColor[1],aFBColor[2],aFBColor[3]) 
       //   
       oSheet:Cells( nLine-1, nI ):Font:Color := RGB(aFColor[1],aFColor[2],aFColor[3])   
   NEXT 
   // -------    ----------------
   //       1  nCount
   //oSheet:Range(oSheet:Cells(nLine-1, 1), oSheet:Cells(nLine-1,nCount)):Interior:Color := RGB(aFBColor[1],aFBColor[2],aFBColor[3]) 

   SELECT( cAlias )
   DbSetOrder(nOrder)
   GOTO TOP

   DO WHILE !EOF()

      FOR nI := 1 TO LEN( aField )
         cPole := aField[ nI , 1 ]
         xValue  := FIELDGET( FIELDNUM( cPole ) )   //   DBF
         nDecPole := FieldDec( FIELDNUM( cPole ) )  //    

         IF cPole == "ORDKEYNO()"
            oSheet:Cells( nLine, nI ):Value := ORDKEYNO()                //   DBF
            oSheet:Cells( nLine, nI ):NumberFormat := '########0'        //  
         ELSE
            oSheet:Cells( nLine, nI ):Value := xValue

            IF FIELDTYPE( cPole ) == "C"
               oSheet:Cells( nLine, nI ):NumberFormat := '@'             //  
               IF AT("", UPPER(xValue) ) > 0
                  lItogo := .T.
               ENDIF
            ELSEIF FIELDTYPE( cPole ) == "N"
               IF nDecPole == 0   //   
                  oSheet:Cells( nLine, nI ):NumberFormat := '## ### ###0'     //  
               ELSE 
                  oSheet:Cells( nLine, nI ):NumberFormat := '## ### ###0,00'  //  
               ENDIF
            ELSE
               oSheet:Cells( nLine, nI ):NumberFormat := '@'                 //  
            ENDIF
         ENDIF
         oSheet:Cells( nLine, nI ):Borders():LineStyle := 1

       NEXT

       nLine ++
       SKIP

       DO EVENTS //  !     

   ENDDO

   IF !lItogo  //  ""  
      nLine := 4  // 4   -     
      oRange := oExcel:ActiveCell:SpecialCells( xlLastCell )
      nRowXls := oRange:Row        //  
      nColXls := oRange:Column     //  
      oSheet:Cells[ 2, nRowXls + 1 ] := ':' 
      oSheet:Cells[ 2, nRowXls + 1 ]:HorizontalAlignment := 4  //     
      oSheet:Cells[ 2, nRowXls + 1 ]:Font:ColorIndex := 3      //  
      oSheet:Cells[ 2, nRowXls + 1 ]:Font:Bold := .T. 

      FOR nI := 3 TO LEN( aField )  //  3   
         oSheet:Cells[ nI, nRowXls + 1 ] := "=(R[-" + HB_NtoS(nRowXls + 1 - nLine) + "]C:R[-1]C)"
         //oSheet:Cells[ nI, nRowXls + 1 ]:NumberFormat := '# ##0,00'
         oSheet:Cells[ nI, nRowXls + 1 ]:Font:ColorIndex := 3  //  
         oSheet:Cells[ nI, nRowXls + 1 ]:Font:Bold := .T. 
         oSheet:Cells[ nI, nRowXls + 1 ]:Borders():LineStyle := 1
      NEXT

   ENDIF              

   // ------ 2  -    (  ) ---------------
   //        ,    
   FOR nI := 1 TO LEN( aField )
     // oSheet:Columns(nI):AutoFit()  //  
   NEXT

   IF nVerExcel > 11 // Excel 2003
      //      2003
      //   ,    -
      // -        
      lSave := .F.
      //MsgDebug(nVerExcel, cFileXls, "CheckCompatibility := FALSE" )
      //oWorkBook:CheckCompatibility := FALSE -  
      //oExcel:ActiveSheet:CheckCompatibility := FALSE
   ENDIF

   IF lSave
      IF FILE(cFileXls)
         nErrDos := DELETEFILE( cFileXls )
         IF nErrDos == 0
            oWorkBook:SaveAs( cFileXls, xlWorkbookNormal )
         ELSE
            cMsg := "    ! (" + HB_NtoS( nErrDos ) + ");" 
            cMsg += cFileXls + ";"
            cMsg += "  -  !" 
            MyStop(cMsg)
         ENDIF
      ELSE
        oWorkBook:SaveAs( cFileXls, xlWorkbookNormal )
      ENDIF    
   ENDIF
   oExcel:Visible = lActivate  //  Excel  

   //   
   cMsg := UPPER(oExcel:ActivePrinter) 
   IF AT("", cMsg ) > 0
      //      
      //  "  (  )"
   ELSE
      oExcel:ActiveSheet:PageSetup:Zoom := FALSE
      oExcel:ActiveSheet:PageSetup:FitToPagesWide := 1
      oExcel:ActiveSheet:PageSetup:FitToPagesTall := 10
      oExcel:ActiveSheet:PageSetup:Orientation := xlLandscape //  - 
   ENDIF

   //   Excel   1     + 1
   //oSheet:Cells[ 1, nRowXls + 2 ]:Select()
   oSheet:Cells[ 1, 2 ]:Select()

   WaitThreadClose()   //   "" / close the "expectations"
   CursorArrow()

   //   Excel   
   hWnd := oExcel:hWnd
   ShowWindow( hWnd, 6 ) //SW_MAXIMIZE=3 SW_NORMAL=1 SW_MINIMIZE=6
   INKEYGUI(100)
   ShowWindow( hWnd, 3 ) //SW_MAXIMIZE=3 SW_NORMAL=1 SW_MINIMIZE=6
   BringWindowToTop( hWnd )

   //_HMG_IsModalActive := .F.  //      

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////
//    Excel
FUNCTION MyExcelVersion()
   LOCAL oExcel, nVer, aDim[20]

   AFILL(aDim,"???")
   aDim[01] := " Excel   !"
   aDim[09] := "Excel 2000"
   aDim[10] := "Excel XP"
   aDim[11] := "Excel 2003"
   aDim[12] := "Excel 2007"
   aDim[14] := "Excel 2010"
   aDim[15] := "Excel 2013"
   aDim[16] := "Excel 2016"
   aDim[17] := "Excel 2019"
   aDim[18] := "Excel New!"

   IF ( oExcel := win_oleCreateObject( "Excel.Application" ) ) == NIL 
      nVer := 1
   ELSE
      oExcel:DisplayAlerts := .F.
      oExcel:visible := .F.
      nVer := VAL( oExcel:Version )
      oExcel:Quit()
   ENDIF

   RETURN { nVer, aDim[nVer] }

///////////////////////////////////////////////////////////////////////////////////////////
//    Excel
// http://clipper.borda.ru/?1-20-0-00000371-000-0-0-1195742832
// Pasha -  N: 645
FUNCTION MyExcelPath()
 LOCAL cPath := NIL 
 cPath := win_regRead( "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\excel.exe\Path" )
Return cPath



