/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2015-2018 Verchenko Andrey <verchenkoag@gmail.com>
 * Many thanks for your help - forum http://clipper.borda.ru
*/

#include "minigui.ch"

//////////////////////////////////////////////////////////////////
//            
FUNCTION FontSizeMaxAutoFit( cText, cFName, nWinWidth )
   LOCAL nTxtWidth, nFSize, lExit := .T.

   nFSize := 6    
   DO WHILE lExit
      nTxtWidth := GetTxtWidth( cText, nFSize, cFName )
      IF nTxtWidth >= nWinWidth 
         lExit := .F.
      ELSE
         nFSize++    
      ENDIF
   ENDDO

   RETURN nFSize

///////////////////////////////////////////////////////////////////////////////
FUNCTION GetTxtWidth( cText, nFontSize, cFontName )  //  Width 
   LOCAL hFont, nWidth
   DEFAULT cText     := REPL('A', 2)        ,  ;
           cFontName := _HMG_DefaultFontName,  ;   //  MiniGUI.Init()
           nFontSize := _HMG_DefaultFontSize       //  MiniGUI.Init()

   IF Valtype(cText) == 'N'
      cText := repl('A', cText)
   ENDIF

   hFont  := InitFont(cFontName, nFontSize)
   nWidth := GetTextWidth(0, cText, hFont)        //   
   DeleteObject (hFont)                    

   RETURN nWidth

///////////////////////////////////////////////////////////////////////////////
FUNCTION GetTxtHeight( cText, nFontSize, cFontName )  //  Height 
   LOCAL hFont, nHeight
   DEFAULT cText     := "B"                 ,  ;
           cFontName := _HMG_DefaultFontName,  ;   //  MiniGUI.Init()
           nFontSize := _HMG_DefaultFontSize       //  MiniGUI.Init()

   hFont := InitFont( cFontName, nFontSize )    
   nHeight := GetTextHeight( 0, cText , hFont )        //   
   DeleteObject( hFont )
   
   RETURN nHeight

///////////////////////////////////////////////////////////////////////////////////////////
//         
//  :        nSizeFont := IIF(Large2Fonts(),9,11)
//   - 120%,  Win7 - 125%
FUNCTION Large2Fonts()  
LOCAL hDC, nPixelX, lRet := .F.  
hDC := CreateDC( "DISPLAY", "", "" ) 
nPixelX := GetDevCaps( hDC ) 
DeleteDC( hDc ) 
IF nPixelX > 100
   lRet := .T.
ENDIF
RETURN (lRet) 

///////////////////////////////////////////////////////////////////////////////////////////
//         
//  :        nSizeFont := IIF(LargeFonts(),9,11)
//   - 120%,  Win7 - 125%
FUNCTION LargeFonts()  
LOCAL hDC, nPixelX  
hDC := CreateDC( "DISPLAY", "", "" ) 
nPixelX := GetDevCaps( hDC ) 
DeleteDC( hDc ) 
RETURN (nPixelX == 120) 

#pragma BEGINDUMP 
#include <windows.h> 
#include "hbapi.h" 
HB_FUNC( CREATEDC ) 
{ 
   hb_retnl( ( LONG ) CreateDC( hb_parc( 1 ), hb_parc( 2 ), hb_parc( 3 ), 0 ) ); 
} 
HB_FUNC( DELETEDC ) 
{ 
   hb_retl( DeleteDC( ( HDC ) hb_parnl( 1 ) ) ); 
} 
HB_FUNC ( GETDEVCAPS ) 
{ 
 INT      ix; 
 HDC      hdc; 
 hdc = ( HDC ) hb_parnl( 1 ); 
     
 ix  = GetDeviceCaps( hdc, LOGPIXELSX );  
    
 hb_retni( (UINT) ix ); 
} 
#pragma ENDDUMP 

//------------------------------------------------------------------------------
#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC( GETKEYBOARDMODE )
{
   HKL kbl;
   HWND CurApp;
   DWORD idthd;
   int newmode;

   CurApp=GetForegroundWindow();
   idthd=GetWindowThreadProcessId(CurApp,NULL);

   kbl=GetKeyboardLayout(idthd);
   newmode=(int)LOWORD(kbl);

   hb_retnl(newmode);
}
#pragma ENDDUMP

